/*
 bdremoteircd: a lirc daemon for the Sony BD Remote
Copyright (C) 2009 D.Herrendoerfer

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#include <stdio.h>
#include <unistd.h>
#include <linux/input.h>

int lastkey = -1;


const char *keys[] = {
        "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "", "ENTER", "", "", "RETURN", "CLEAR",
        "", "", "", "", "", "", "EJECT", "", "", "", "TOPMENU", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "TIME", "", "", "", "", "", "", "",
        "PREV", "NEXT", "PLAY", "FASTRWD", "FASTFWD", "", "", "", "STOP", "PAUSE", "", "", "", "", "", "",
        "MENU", "", "", "PSBUTTON", "", "", "", "", "", "", "", "", "", "", "", "",
        "SELECT", "L3", "R3", "START", "UP", "RIGHT", "DOWN", "LEFT", "L2", "R2", "L1", "R1", "OPTIONS", "BACK", "CROSS", "VIEW",
        "SLOWRWD", "SLOWFWD", "", "SUBTITLE", "AUDIO", "ANGLE", "", "", "", "", "", "", "", "", "", "",
        "DISPLAY", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "BLUE", "RED", "GREEN", "YELLOW", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
        "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""
};

int get_key(int efd, char* lircmsg)
{
        unsigned char msg[12];
        int rd;
	unsigned char value;

        if ((rd = read (efd, msg, 12)) < 12)
                return -1;

//	printf ("0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x\n", 
//	         msg[0], msg[1], msg[2], msg[3], msg[4], msg[5], msg[6], msg[7]);
//	printf ("0x%02x 0x%02x 0x%02x 0x%02x\n", msg[8], msg[9], msg[10], msg[11] );

        value = (unsigned char)msg[4];
        
        if (msg[10] == 0x01) {
		if (msg[4] == 0xff) {
			return 2;
		} 
//        	printf ("0x0%02x = %s\n", value,keys[value]);
       		sprintf(lircmsg,"000000000000%04x %02i %s BDREMOTE\n"
			,value,0,keys[value]);

		return 1;
	}
	else if (msg[10] == 0x00) {
		return 0;
	}
	
	return -1;
}
